<i18n>
  {
    "fr": {
      "tooltip-1": "Désoumettre le module",
      "message-1": "Désoumettre un BGES",
      "message-2": "Souhaitez vous désoumettre les données du module",
      "message-3": "du BGES"
    },
    "en": {
      "tooltip-1": "Unsubmit module",
      "message-1": "Unsubmit a GHGI",
      "message-2": "Are you sure you want to unsubmit the data of the",
      "message-3": "module of the GHGI"
    }
  }
</i18n>

<template>
  <div>
    <div class="columns">
      <div class="column">
        <b-notification :closable="false">
          Par default les BGES listés dans le tableau sont chargés sans les données
          de consommation des différents module. Afin de charger les BGES avec leurs
          données de consommation pour lesquels les modules ont été soumis, vous pouvez
          sélectionner sur votre droite les modules d'interêts.
          Pour charger l'ensemble des BGES et leur données ne selectionnez aucun module.
          <br />
          Les données des BGES chargés peuvent alors être téléchargées en sélectionnant le
          type de données que vous souhaitez.
        </b-notification>
        <div class="columns">
          <div class="column">
            <b-notification :closable="false">
              <div class="level-item has-text-centered">
                <div>
                  <p>
                    #Bilans GES
                  </p>
                  <div class="title is-size-4">
                    <p>
                      <span>{{ allGHGI.length }}</span>
                    </p>
                  </div>
                </div>
              </div>
            </b-notification>
          </div>
          <div class="column is-vcentered">
            <b-notification :closable="false">
              <b-dropdown
                :disabled="allGHGI.length == 0 || !('emissions' in allGHGI[0])"
                v-model="cModule"
                aria-role="list"
                expanded
              >
                <template #trigger>
                  <b-button
                    :label="'Exporter ('+allGHGI.length+' BGES)'"
                    expanded
                    icon-left="download"
                    icon-right="caret-down"
                  />
                </template>
                <b-dropdown-item
                  v-for="(module, index) in modules"
                  :key="index"
                  :value="module" aria-role="listitem">
                  <div class="media">
                    <b-icon class="media-left" :icon="module.icon"></b-icon>
                    <div class="media-content">
                      <h3>{{ module.text }}</h3>
                    </div>
                  </div>
                </b-dropdown-item>
              </b-dropdown>
            </b-notification>
          </div>
        </div>
      </div>
      <div class="column is-4">
        <b-notification :closable="false">
          <b-checkbox v-model="buildingsSubmitted">
            Les batiments
          </b-checkbox>
          <br />
          <b-checkbox v-model="devicesSubmitted">
            Matériel informatique
          </b-checkbox>
          <br />
          <b-checkbox v-model="purchasesSubmitted">
            Les achats
          </b-checkbox>
          <br />
          <b-checkbox v-model="vehiclesSubmitted">
            Les véhicules
          </b-checkbox>
          <br />
          <b-checkbox v-model="travelsSubmitted">
            Les Missions
          </b-checkbox>
          <br />
          <b-checkbox v-model="commutesSubmitted">
            Les dpts domicile / travail
          </b-checkbox>
        </b-notification>
        <b-button
          label="Charger les consommations"
          type="is-primary"
          icon-left="cloud-download"
          @click="loadData"
          expanded
        />
      </div>
    </div>
    <br />
    <b-table
      :data="allGHGI"
      :striped="true"
      :hoverable="true"
      :sort-icon="'angle-up'"
      paginated
      per-page="50"
      default-sort="submitted"
      detailed
      detail-transition="fade"
    >
      <b-table-column field="year" searchable sortable label="Année" centered v-slot="props">
        {{ props.row.year }}
      </b-table-column>
      <b-table-column field="laboratory.name" searchable sortable label="Laboratoire" centered v-slot="props">
        {{ props.row.laboratory.name }}
      </b-table-column>
      <b-table-column field="laboratory.mainSite" searchable sortable label="Localisation" centered v-slot="props">
        {{ props.row.laboratory.mainSite }}
      </b-table-column>
      <b-table-column field="laboratory.referent.email" searchable sortable label="Référant" centered v-slot="props">
        {{ props.row.laboratory.referent.email }}
      </b-table-column>
      <b-table-column field="budget" sortable label="Budget" centered v-slot="props">
        {{ props.row.budget }}
      </b-table-column>
      <b-table-column label="Effectifs" centered v-slot="props">
        {{ props.row.nResearcher + props.row.nProfessor + props.row.nEngineer + props.row.nStudent }}
      </b-table-column>
      <b-table-column label="Soumission" v-slot="props">
        <div class="panel-block">
          <b-tooltip
            v-for="(module, index) in allModules"
            :key="index"
            :label="$t('tooltip-1') + ' ' + $t(module)"
            type="is-black"
          >
            <b-button
              size="is-small"
              :icon-left="iconModules[module]"
              :disabled="!props.row[module+'Submitted']"
              :type="props.row[module+'Submitted'] ? 'is-info' : ''"
              @click="UnsubmitData(props.row, module+'Submitted', module)"
            />
          </b-tooltip>
        </div>
      </b-table-column>
      <template #detail="props">
        <article v-if="'emissions' in props.row" class="media">
          <div class="media-content">
            <div class="content">
              <p>
                <strong>Véhicules :</strong> {{ Math.round(props.row.emissions.vehicles.intensity.intensity) }} kg eCO2 &plusmn; {{ Math.round(props.row.emissions.vehicles.intensity.uncertainty) }} kg eCO2
                <br />
                <strong>Chauffage :</strong> {{ Math.round(props.row.emissions.buildings.heatings.intensity.intensity) }} kg eCO2 &plusmn; {{ Math.round(props.row.emissions.buildings.heatings.intensity.uncertainty) }} kg eCO2
                <br />
                <strong>Electricite :</strong> {{ Math.round(props.row.emissions.buildings.electricity.intensity) }} kg eCO2 &plusmn; {{ Math.round(props.row.emissions.buildings.electricity.uncertainty) }} kg eCO2
                <br />
                <strong>Gaz Réfrigerant :</strong> {{ Math.round(props.row.emissions.buildings.refrigerants.intensity) }} kg eCO2 &plusmn; {{ Math.round(props.row.emissions.buildings.refrigerants.uncertainty) }} kg eCO2
                <br />
                <strong>Missions :</strong> {{ Math.round(props.row.emissions.travels.intensity.intensity) }} kg eCO2 &plusmn; {{ Math.round(props.row.emissions.travels.intensity.uncertainty) }} kg eCO2
                <br />
                <strong>Dpts domicile / travail :</strong> {{ Math.round(props.row.emissions.commutes.intensity.intensity) }} kg eCO2 &plusmn; {{ Math.round(props.row.emissions.commutes.intensity.uncertainty) }} kg eCO2
                <br />
                <strong>Matériel informatique :</strong> {{ Math.round(props.row.emissions.devices.intensity.intensity) }} kg eCO2 &plusmn; {{ Math.round(props.row.emissions.devices.intensity.uncertainty) }} kg eCO2
                <br />
                <strong>Achats :</strong> {{ Math.round(props.row.emissions.purchases.intensity.intensity) }} kg eCO2 &plusmn; {{ Math.round(props.row.emissions.purchases.intensity.uncertainty) }} kg eCO2
              </p>
            </div>
          </div>
        </article>
      </template>
      <section slot="empty" class="section">
        <div class="content has-text-grey has-text-centered">
          <p>
            <i class="sui sui-ban" style="font-size: 64px;"></i>
          </p>
          <p>Aucun BGES</p>
        </div>
      </section>
    </b-table>
    <br />
    <nav class="level">
      <div class="level-left"></div>
      <div class="buttons level-right">
      </div>
    </nav>
  </div>
</template>

<script>
import { mapGetters } from 'vuex'

export default {
  name: 'GES1point5Admin',
  data () {
    return {
      cModule: { icon: '', text: '' },
      allModules: ['buildings', 'purchases', 'devices', 'vehicles', 'travels', 'commutes'],
      iconModules: {
        'buildings': 'building',
        'purchases': 'euro',
        'devices': 'desktop',
        'vehicles': 'car',
        'travels': 'train',
        'commutes': 'bicycle'
      },
      buildingsSubmitted: false,
      vehiclesSubmitted: false,
      devicesSubmitted: false,
      travelsSubmitted: false,
      commutesSubmitted: false,
      purchasesSubmitted: false,
      error: '',
      modules: [
        { icon: 'flask', text: 'BGES laboratoire (admin)', func: this.exportAllLabsEmissionsFull },
        { icon: 'flask', text: 'BGES laboratoire', func: this.exportAllLabsEmissions },
        { icon: 'building', text: 'Les batiments', func: this.exportBuildings },
        { icon: 'eur', text: 'Les achats', func: this.exportPurchases },
        { icon: 'desktop', text: 'Matériel informatique', func: this.exportComputerDevices },
        { icon: 'car', text: 'Les véhicules', func: this.exportVehicles },
        { icon: 'train', text: 'Les Missions', func: this.exportTravels },
        { icon: 'bicycle', text: 'Les dpts domicile / travail', func: this.exportCommutes }
      ]
    }
  },
  watch: {
    cModule: function () {
      this.cModule.func()
    }
  },
  computed: {
    ...mapGetters('authentication', ['isAuthenticated']),
    allGHGI: function () {
      return this.$store.getters['superadmin/allGHGI']
    }
  },
  methods: {
    loadData: function () {
      const loadingComponent = this.$buefy.loading.open({
        container: null
      })
      this.$store.dispatch('superadmin/getAllGHGIWithConsumptions', {
        'buildingsSubmitted': this.buildingsSubmitted,
        'vehiclesSubmitted': this.vehiclesSubmitted,
        'devicesSubmitted': this.devicesSubmitted,
        'travelsSubmitted': this.travelsSubmitted,
        'commutesSubmitted': this.commutesSubmitted,
        'purchasesSubmitted': this.purchasesSubmitted
      })
        .then(data => {
          loadingComponent.close()
        })
        .catch(() => {
          loadingComponent.close()
        })
    },
    UnsubmitData: function (ghgi, variable, module) {
      let self = this
      this.$buefy.dialog.confirm({
        title: self.$t('message-1'),
        message: self.$t('message-2') + ' <strong>' + self.$t(module) + '</strong> ' + self.$t('message-3') + ' <strong>' + ghgi.year + '</strong>.',
        confirmText: self.$t('validate'),
        cancelText: self.$t('cancel'),
        canCancel: ['escape', 'button', 'outside'],
        onConfirm: function () {
          const loadingComponent = self.$buefy.loading.open({
            container: null
          })
          self.$store.dispatch('superadmin/unsubmitData', {
            'ghgi': ghgi.id,
            'variable': variable
          })
            .then(data => {
              loadingComponent.close()
            })
            .catch(() => {
              loadingComponent.close()
            })
        }
      })
    },
    getTotal: function (props) {
      return Math.round(props.row.emissions.vehicles.intensity.intensity) +
        Math.round(props.row.emissions.buildings.heatings.intensity.intensity) +
        Math.round(props.row.emissions.buildings.electricity.intensity) +
        Math.round(props.row.emissions.buildings.refrigerants.intensity) +
        Math.round(props.row.emissions.travels.intensity.intensity) +
        Math.round(props.row.emissions.commutes.intensity.intensity) +
        Math.round(props.row.emissions.devices.intensity.intensity) +
        Math.round(props.row.emissions.purchases.intensity.intensity)
    },
    exportPurchases: function () {
      let csvContent = 'data:text/csv;charset=utf-8,'
      let now = new Date()
      let self = this
      let month = now.getMonth() + 1
      csvContent += ['ghgi.uuid', 'code', 'module', 'scope.source', 'category', 'description',
        'amount.euro', 'emission.kg.co2e', 'uncertainty.kg.co2e'].join('\t') + '\n'
      for (let ghgi of this.allGHGI) {
        for (let purchase of ghgi.emissions.purchases.meta) {
          csvContent += ghgi.uuid + '\t' + purchase.code.toUpperCase() + '\t'
          csvContent += purchase.module + '\t'
          csvContent += purchase.scope3 + '\t' + self.$t(purchase.category) + '\t'
          csvContent += purchase.description + '\t' + purchase.amount + '\t'
          csvContent += Math.round(purchase.intensity.intensity) + '\t' + Math.round(purchase.intensity.uncertainty) + '\n'
        }
      }
      const data = encodeURI(csvContent)
      const link = document.createElement('a')
      link.setAttribute('href', data)
      link.setAttribute('download', 'GES1point5export_purchases_' + now.getFullYear() + '' + month + '' + now.getDate() + '.tsv')
      link.click()
    },
    exportCommutes: function () {
      let csvContent = 'data:text/csv;charset=utf-8,'
      let now = new Date()
      let month = now.getMonth() + 1
      /* csvContent += ['ghgi.uuid', 'days.per.week', 'position', 'walking.d1.km', 'bike.d1.km',
          'ebike.d1.km', 'escooter.d1.km', '2.wheeler.d1.km', 'car.d1.km', 'bus.d1.km',
          'tramway.d1.km', 'train.d1.km', 'rer.d1.km', 'subway.d1.km', 'days.d2',
          'walking.d2.km', 'bike.d2.km', 'ebike.d2.km', 'escooter.d2.km', '2.wheeler.d2.km',
          'car.d2.km', 'bus.d2.km', 'tramway.d2.km', 'train.d2.km', 'rer.d2.km', 'subway.d2.km',
          'walking.kg.co2e)', 'bike.kg.co2e', 'ebike.kg.co2e', 'escooter.kg.co2e',
          '2.wheeler.kg.co2e', 'car.kg.co2e', 'bus.kg.co2e', 'tramway.kg.co2e', 'train.kg.co2e', 'RER (kg eCO2)',
          'subway.kg.co2e', 'emission.kg.co2e', 'uncertainty.kg.co2e'].join('\t') + '\n' */
      csvContent += ['ghgi.uuid',

        'no.answers.researcher', 'commuting.days.researcher', 'walking.researcher.km', 'bike.researcher.km', 'ebike.researcher.km',
        'escooter.researcher.km', '2.wheeler.researcher.km', 'car.researcher.km', 'bus.researcher.km', 'busintercity.researcher.km',
        'tramway.researcher.km', 'train.researcher.km', 'rer.researcher.km', 'subway.researcher.km',
        'walking.researcher.emission.kg.co2e', 'bike.researcher.emission.kg.co2e', 'ebike.researcher.emission.kg.co2e',
        'escooter.researcher.emission.kg.co2e', '2.wheeler.researcher.emission.kg.co2e', 'car.researcher.emission.kg.co2e', 'bus.researcher.emission.kg.co2e', 'busintercity.researcher.emission.kg.co2e',
        'tramway.researcher.emission.kg.co2e', 'train.researcher.emission.kg.co2e', 'rer.researcher.emission.kg.co2e', 'subway.researcher.emission.kg.co2e',
        'walking.researcher.uncertainty.kg.co2e', 'bike.researcher.uncertainty.kg.co2e', 'ebike.researcher.uncertainty.kg.co2e',
        'escooter.researcher.uncertainty.kg.co2e', '2.wheeler.researcher.uncertainty.kg.co2e', 'car.researcher.uncertainty.kg.co2e', 'bus.researcher.uncertainty.kg.co2e', 'busintercity.researcher.uncertainty.kg.co2e',
        'tramway.researcher.uncertainty.kg.co2e', 'train.researcher.uncertainty.kg.co2e', 'rer.researcher.uncertainty.kg.co2e', 'subway.researcher.uncertainty.kg.co2e',

        'no.answers.engineer', 'commuting.days.engineer', 'walking.engineer.km', 'bike.engineer.km', 'ebike.engineer.km',
        'escooter.engineer.km', '2.wheeler.engineer.km', 'car.engineer.km', 'bus.engineer.km', 'busintercity.engineer.km',
        'tramway.engineer.km', 'train.engineer.km', 'rer.engineer.km', 'subway.engineer.km',
        'walking.engineer.emission.kg.co2e', 'bike.engineer.emission.kg.co2e', 'ebike.engineer.emission.kg.co2e',
        'escooter.engineer.emission.kg.co2e', '2.wheeler.engineer.emission.kg.co2e', 'car.engineer.emission.kg.co2e', 'bus.engineer.emission.kg.co2e', 'busintercity.engineer.emission.kg.co2e',
        'tramway.engineer.emission.kg.co2e', 'train.engineer.emission.kg.co2e', 'rer.engineer.emission.kg.co2e', 'subway.engineer.emission.kg.co2e',
        'walking.engineer.uncertainty.kg.co2e', 'bike.engineer.uncertainty.kg.co2e', 'ebike.engineer.uncertainty.kg.co2e',
        'escooter.engineer.uncertainty.kg.co2e', '2.wheeler.engineer.uncertainty.kg.co2e', 'car.engineer.uncertainty.kg.co2e', 'bus.engineer.uncertainty.kg.co2e', 'busintercity.engineer.uncertainty.kg.co2e',
        'tramway.engineer.uncertainty.kg.co2e', 'train.engineer.uncertainty.kg.co2e', 'rer.engineer.uncertainty.kg.co2e', 'subway.engineer.uncertainty.kg.co2e',

        'no.answers.student', 'commuting.days.student', 'walking.student.km', 'bike.student.km', 'ebike.student.km',
        'escooter.student.km', '2.wheeler.student.km', 'car.student.km', 'bus.student.km','busintercity.student.km',
        'tramway.student.km', 'train.student.km', 'rer.student.km', 'subway.student.km',
        'walking.student.emission.kg.co2e', 'bike.student.emission.kg.co2e', 'ebike.student.emission.kg.co2e',
        'escooter.student.emission.kg.co2e', '2.wheeler.student.emission.kg.co2e', 'car.student.emission.kg.co2e', 'bus.student.emission.kg.co2e', 'busintercity.student.emission.kg.co2e',
        'tramway.student.emission.kg.co2e', 'train.student.emission.kg.co2e', 'rer.student.emission.kg.co2e', 'subway.student.emission.kg.co2e',
        'walking.student.uncertainty.kg.co2e', 'bike.student.uncertainty.kg.co2e', 'ebike.student.uncertainty.kg.co2e',
        'escooter.student.uncertainty.kg.co2e', '2.wheeler.student.uncertainty.kg.co2e', 'car.student.uncertainty.kg.co2e', 'bus.student.uncertainty.kg.co2e', 'busintercity.student.uncertainty.kg.co2e',
        'tramway.student.uncertainty.kg.co2e', 'train.student.uncertainty.kg.co2e', 'rer.student.uncertainty.kg.co2e', 'subway.student.uncertainty.kg.co2e',

        'emission.kg.co2e', 'uncertainty.kg.co2e'].join('\t') + '\n'
      for (let ghgi of this.allGHGI) {
        csvContent += ghgi.uuid + '\t'
        csvContent += ghgi.emissions.commutes.nbAnswers.researcher + '\t' + ghgi.emissions.commutes.cdays.researcher + '\t'
        csvContent += ghgi.emissions.commutes.status.distances.researcher.map(obj => Math.round(obj)).join('\t') + '\t'
        csvContent += ghgi.emissions.commutes.status.intensity.researcher.map(obj => Math.round(obj.intensity)).join('\t') + '\t'
        csvContent += ghgi.emissions.commutes.status.intensity.researcher.map(obj => Math.round(obj.uncertainty)).join('\t') + '\t'
        csvContent += ghgi.emissions.commutes.nbAnswers.engineer + '\t' + ghgi.emissions.commutes.cdays.engineer + '\t'
        csvContent += ghgi.emissions.commutes.status.distances.engineer.map(obj => Math.round(obj)).join('\t') + '\t'
        csvContent += ghgi.emissions.commutes.status.intensity.engineer.map(obj => Math.round(obj.intensity)).join('\t') + '\t'
        csvContent += ghgi.emissions.commutes.status.intensity.engineer.map(obj => Math.round(obj.uncertainty)).join('\t') + '\t'
        csvContent += ghgi.emissions.commutes.nbAnswers.student + '\t' + ghgi.emissions.commutes.cdays.student + '\t'
        csvContent += ghgi.emissions.commutes.status.distances.student.map(obj => Math.round(obj)).join('\t') + '\t'
        csvContent += ghgi.emissions.commutes.status.intensity.student.map(obj => Math.round(obj.intensity)).join('\t') + '\t'
        csvContent += ghgi.emissions.commutes.status.intensity.student.map(obj => Math.round(obj.uncertainty)).join('\t') + '\t'
        csvContent += Math.round(ghgi.emissions.commutes.intensity.intensity) + '\t' + Math.round(ghgi.emissions.commutes.intensity.uncertainty) + '\n'
      }
      const data = encodeURI(csvContent)
      const link = document.createElement('a')
      link.setAttribute('href', data)
      link.setAttribute('download', 'GES1point5export_commutes_' + now.getFullYear() + '' + month + '' + now.getDate() + '.tsv')
      link.click()
    },
    exportComputerDevices: function () {
      let csvContent = 'data:text/csv;charset=utf-8,'
      let now = new Date()
      let month = now.getMonth() + 1
      csvContent += ['ghgi.uuid', 'type', 'model', 'amount',
        'emission.kg.co2e', 'uncertainty.kg.co2e'].join('\t') + '\n'
      for (let ghgi of this.allGHGI) {
        for (let device of ghgi.emissions.devices.meta) {
          csvContent += ghgi.uuid + '\t' + device.type + '\t' + device.model + '\t'
          csvContent += device.amount + '\t'
          csvContent += Math.round(device.intensity.intensity) + '\t' + Math.round(device.intensity.uncertainty) + '\n'
        }
      }
      const data = encodeURI(csvContent)
      const link = document.createElement('a')
      link.setAttribute('href', data)
      link.setAttribute('download', 'GES1point5export_devices_' + now.getFullYear() + '' + month + '' + now.getDate() + '.tsv')
      link.click()
    },
    exportBuildings: function () {
      let csvContent = 'data:text/csv;charset=utf-8,'
      let now = new Date()
      let month = now.getMonth() + 1
      csvContent += ['ghgi.uuid', 'floor.area', 'share', 'self.production',
        'self.consumption', 'heating.emission.kg.co2e', 'heating.uncertainty.kg.co2e',
        'electricity.emission.kg.co2e', 'electricity.uncertainty.kg.co2e',
        'refrigerants.emission.kg.co2e', 'refrigerants.uncertainty.kg.co2e'].join('\t') + '\n'
      for (let ghgi of this.allGHGI) {
        for (let building of ghgi.emissions.buildings.meta) {
          csvContent += ghgi.uuid + '\t' + building.area + '\t' + building.share + '\t'
          csvContent += building.selfProduction + '\t' + building.selfConsumption + '\t'
          csvContent += Math.round(building.heatingIntensity.intensity) + '\t' + Math.round(building.heatingIntensity.uncertainty) + '\t'
          csvContent += Math.round(building.electricityIntensity.intensity) + '\t' + Math.round(building.electricityIntensity.uncertainty) + '\t'
          csvContent += Math.round(building.refrigerantsIntensity.intensity) + '\t' + Math.round(building.refrigerantsIntensity.uncertainty) + '\n'
        }
      }
      const data = encodeURI(csvContent)
      const link = document.createElement('a')
      link.setAttribute('href', data)
      link.setAttribute('download', 'GES1point5export_buildings_' + now.getFullYear() + '' + month + '' + now.getDate() + '.tsv')
      link.click()
    },
    exportVehicles: function () {
      let csvContent = 'data:text/csv;charset=utf-8,'
      let now = new Date()
      let month = now.getMonth() + 1
      csvContent += ['ghgi.uuid', 'type', 'engine', 'consumption', 'unit',
        'emission.kg.co2e', 'uncertainty.kg.co2e'].join('\t') + '\n'
      for (let ghgi of this.allGHGI) {
        for (let vehicle of ghgi.emissions.vehicles.meta) {
          csvContent += ghgi.uuid + '\t' + vehicle.type + '\t' + vehicle.engine + '\t'
          csvContent += vehicle.consumption + '\t' + vehicle.unit + '\t'
          csvContent += Math.round(vehicle.intensity.intensity) + '\t' + Math.round(vehicle.intensity.uncertainty) + '\n'
        }
      }
      const data = encodeURI(csvContent)
      const link = document.createElement('a')
      link.setAttribute('href', data)
      link.setAttribute('download', 'GES1point5export_vehicles_' + now.getFullYear() + '' + month + '' + now.getDate() + '.tsv')
      link.click()
    },
    exportTravels: function () {
      let csvContent = 'data:text/csv;charset=utf-8,'
      let now = new Date()
      let month = now.getMonth() + 1
      csvContent += ['ghgi.uuid', 'type', 'mode', 'amount', 'position', 'no.person', 'purpose',
        'round.trip', 'geodesic.distance.km', 'corrected.distance.km', 'distance.km', 'cumulative.distance.km',
        'emission.kg.co2e', 'uncertainty.kg.co2e', 'emission.withcontrails.kg.co2e',
        'uncertainty.withcontrails.kg.co2e'].join('\t') + '\n'
      for (let ghgi of this.allGHGI) {
        for (let travel of ghgi.emissions.travels.meta) {
          csvContent += ghgi.uuid + '\t' + travel.type + '\t' + travel.transportation + '\t'
          csvContent += travel.amount + '\t' + travel.status + '\t'
          csvContent += travel.carpooling + '\t' + travel.purpose + '\t'
          csvContent += travel.isRoundTrip + '\t' + travel.geodesicDistance + '\t'
          csvContent += travel.correctedDistance + '\t' + travel.distance + '\t'
          csvContent += travel.cumulativeDistance + '\t'
          csvContent += Math.round(travel.intensity.intensity) + '\t' + Math.round(travel.intensity.uncertainty) + '\t'
          csvContent += Math.round(travel.intensity.intensitywc) + '\t' + Math.round(travel.intensity.uncertaintywc) + '\n'
        }
      }
      const data = encodeURI(csvContent)
      const link = document.createElement('a')
      link.setAttribute('href', data)
      link.setAttribute('download', 'GES1point5export_travels_' + now.getFullYear() + '' + month + '' + now.getDate() + '.tsv')
      link.click()
    },
    exportAllLabsEmissions: function () {
      let csvContent = 'data:text/csv;charset=utf-8,'
      let now = new Date()
      let month = now.getMonth() + 1
      csvContent += [
        ['ghgi.uuid', 'created.date', 'year', 'lab.id', 'supervisions', 'disciplines',
          'city', 'country', 'region', 'no.researchers', 'no.teacher', 'no.ita', 'no.postdoc', 'budget', 'vehicles.submitted',
          'vehicles.emission.kg.co2e', 'vehicles.uncertainty.kg.co2e', 'travels.submitted', 'travels.emission.kg.co2e',
          'travels.uncertainty.kg.co2e', 'travelswc.emission.kg.co2e', 'travelswc.uncertainty.kg.co2e', 'commutes.submitted',
          'commutes.emission.kg.co2e', 'commutes.uncertainty.kg.co2e', 'heating.submitted', 'heating.emission.kg.co2e',
          'heating.uncertainty.kg.co2e', 'electricity.submitted', 'electricity.emission.kg.co2e', 'electricity.uncertainty.kg.co2e',
          'cooling.submitted', 'cooling.emission.kg.co2e', 'cooling.uncertainty.kg.co2e', 'devices.submitted',
          'devices.emission.kg.co2e', 'devices.uncertainty.kg.co2e', 'purchases.submitted', 'purchases.emission.kg.co2e', 'purchases.uncertainty.kg.co2e'].join('\t'),
        ...this.allGHGI.map(function (ghgi) {
          let toReturn = ghgi.uuid + '\t' + ghgi.created + '\t' + ghgi.year + '\t' + ghgi.laboratory.id
          toReturn += '\t' + ghgi.laboratory.administrations.map(obj => obj.name).join(';')
          toReturn += '\t' + ghgi.laboratory.disciplines.map(obj => obj.name + ':' + obj.percentage).join(';')
          toReturn += '\t' + ghgi.laboratory.mainSite + '\t' + ghgi.laboratory.country + '\t' + ghgi.laboratory.area
          toReturn += '\t' + ghgi.nResearcher + '\t' + ghgi.nProfessor + '\t' + ghgi.nEngineer + '\t' + ghgi.nStudent + '\t' + ghgi.budget
          if (ghgi.emissions.vehicles !== null) {
            toReturn += '\t' + ghgi.vehiclesSubmitted + '\t' + Math.round(ghgi.emissions.vehicles.intensity.intensity) + '\t' + Math.round(ghgi.emissions.vehicles.intensity.uncertainty)
          } else {
            toReturn += '\tfalse\tnull\tnull'
          }
          if (ghgi.emissions.travels !== null) {
            toReturn += '\t' + ghgi.travelsSubmitted + '\t' + Math.round(ghgi.emissions.travels.intensity.intensity) + '\t' + Math.round(ghgi.emissions.travels.intensity.uncertainty)
            toReturn += '\t' + Math.round(ghgi.emissions.travels.intensity.intensitywc) + '\t' + Math.round(ghgi.emissions.travels.intensity.uncertaintywc)
          } else {
            toReturn += '\tfalse\tnull\tnull\tnull\tnull'
          }
          if (ghgi.emissions.commutes !== null) {
            toReturn += '\t' + ghgi.commutesSubmitted + '\t' + Math.round(ghgi.emissions.commutes.intensity.intensity) + '\t' + Math.round(ghgi.emissions.commutes.intensity.uncertainty)
          } else {
            toReturn += '\tfalse\tnull\tnull'
          }
          if (ghgi.emissions.buildings !== null) {
            toReturn += '\t' + ghgi.buildingsSubmitted + '\t' + Math.round(ghgi.emissions.buildings.heatings.intensity.intensity) + '\t' + Math.round(ghgi.emissions.buildings.heatings.intensity.uncertainty)
            toReturn += '\t' + ghgi.buildingsSubmitted + '\t' + Math.round(ghgi.emissions.buildings.electricity.intensity) + '\t' + Math.round(ghgi.emissions.buildings.electricity.uncertainty)
            toReturn += '\t' + ghgi.buildingsSubmitted + '\t' + Math.round(ghgi.emissions.buildings.refrigerants.intensity) + '\t' + Math.round(ghgi.emissions.buildings.refrigerants.uncertainty)
          } else {
            toReturn += '\tfalse\tnull\tnull\tfalse\tnull\tnull\tfalse\tnull\tnull'
          }
          if (ghgi.emissions.devices !== null) {
            toReturn += '\t' + ghgi.devicesSubmitted + '\t' + Math.round(ghgi.emissions.devices.intensity.intensity) + '\t' + Math.round(ghgi.emissions.devices.intensity.uncertainty)
          } else {
            toReturn += '\tfalse\tnull\tnull'
          }
          if (ghgi.emissions.purchases !== null) {
            toReturn += '\t' + ghgi.purchasesSubmitted + '\t' + Math.round(ghgi.emissions.purchases.intensity.intensity) + '\t' + Math.round(ghgi.emissions.purchases.intensity.uncertainty)
          } else {
            toReturn += '\tfalse\tnull\tnull'
          }
          return (toReturn)
        })
      ]
        .join('\n')
        .replace(/(^\[)|(\]$)/gm, '')
      const data = encodeURI(csvContent)
      const link = document.createElement('a')
      link.setAttribute('href', data)
      link.setAttribute('download', 'GES1point5export_' + now.getFullYear() + '' + month + '' + now.getDate() + '.tsv')
      link.click()
    },
    exportAllLabsEmissionsFull: function () {
      let csvContent = 'data:text/csv;charset=utf-8,'
      let now = new Date()
      let month = now.getMonth() + 1
      csvContent += [
        ['ghgi.uuid', 'created.date', 'year', 'referent.email', 'lab.id', 'lab.name', 'supervisions', 'disciplines',
          'city', 'country', 'region', 'no.researchers', 'no.teacher', 'no.ita', 'no.postdoc', 'budget', 'vehicles.submitted',
          'vehicles.emission.kg.co2e', 'vehicles.uncertainty.kg.co2e', 'travels.submitted', 'travels.emission.kg.co2e',
          'travels.uncertainty.kg.co2e', 'travelswc.emission.kg.co2e', 'travelswc.uncertainty.kg.co2e', 'commutes.submitted',
          'commutes.emission.kg.co2e', 'commutes.uncertainty.kg.co2e', 'heating.submitted', 'heating.emission.kg.co2e',
          'heating.uncertainty.kg.co2e', 'electricity.submitted', 'electricity.emission.kg.co2e', 'electricity.uncertainty.kg.co2e',
          'cooling.submitted', 'cooling.emission.kg.co2e', 'cooling.uncertainty.kg.co2e', 'devices.submitted',
          'devices.emission.kg.co2e', 'devices.uncertainty.kg.co2e', 'purchases.submitted', 'purchases.emission.kg.co2e',
          'purchases.uncertainty.kg.co2e'].join('\t'),
        ...this.allGHGI.map(function (ghgi) {
          let toReturn = ghgi.uuid + '\t' + ghgi.created + '\t' + ghgi.year + '\t' + ghgi.laboratory.referent.email + '\t' + ghgi.laboratory.id
          toReturn += '\t' + ghgi.laboratory.name + '\t' + ghgi.laboratory.administrations.map(obj => obj.name).join(';')
          toReturn += '\t' + ghgi.laboratory.disciplines.map(obj => obj.name + ':' + obj.percentage).join(';')
          toReturn += '\t' + ghgi.laboratory.mainSite + '\t' + ghgi.laboratory.country + '\t' + ghgi.laboratory.area
          toReturn += '\t' + ghgi.nResearcher + '\t' + ghgi.nProfessor + '\t' + ghgi.nEngineer + '\t' + ghgi.nStudent + '\t' + ghgi.budget
          if (ghgi.emissions.vehicles !== null) {
            toReturn += '\t' + ghgi.vehiclesSubmitted + '\t' + Math.round(ghgi.emissions.vehicles.intensity.intensity) + '\t' + Math.round(ghgi.emissions.vehicles.intensity.uncertainty)
          } else {
            toReturn += '\tfalse\tnull\tnull'
          }
          if (ghgi.emissions.travels !== null) {
            toReturn += '\t' + ghgi.travelsSubmitted + '\t' + Math.round(ghgi.emissions.travels.intensity.intensity) + '\t' + Math.round(ghgi.emissions.travels.intensity.uncertainty)
            toReturn += '\t' + Math.round(ghgi.emissions.travels.intensity.intensitywc) + '\t' + Math.round(ghgi.emissions.travels.intensity.uncertaintywc)
          } else {
            toReturn += '\tfalse\tnull\tnull\tnull\tnull'
          }
          if (ghgi.emissions.commutes !== null) {
            toReturn += '\t' + ghgi.commutesSubmitted + '\t' + Math.round(ghgi.emissions.commutes.intensity.intensity) + '\t' + Math.round(ghgi.emissions.commutes.intensity.uncertainty)
          } else {
            toReturn += '\tfalse\tnull\tnull'
          }
          if (ghgi.emissions.buildings !== null) {
            toReturn += '\t' + ghgi.buildingsSubmitted + '\t' + Math.round(ghgi.emissions.buildings.heatings.intensity.intensity) + '\t' + Math.round(ghgi.emissions.buildings.heatings.intensity.uncertainty)
            toReturn += '\t' + ghgi.buildingsSubmitted + '\t' + Math.round(ghgi.emissions.buildings.electricity.intensity) + '\t' + Math.round(ghgi.emissions.buildings.electricity.uncertainty)
            toReturn += '\t' + ghgi.buildingsSubmitted + '\t' + Math.round(ghgi.emissions.buildings.refrigerants.intensity) + '\t' + Math.round(ghgi.emissions.buildings.refrigerants.uncertainty)
          } else {
            toReturn += '\tfalse\tnull\tnull\tfalse\tnull\tnull\tfalse\tnull\tnull'
          }
          if (ghgi.emissions.devices !== null) {
            toReturn += '\t' + ghgi.devicesSubmitted + '\t' + Math.round(ghgi.emissions.devices.intensity.intensity) + '\t' + Math.round(ghgi.emissions.devices.intensity.uncertainty)
          } else {
            toReturn += '\tfalse\tnull\tnull'
          }
          if (ghgi.emissions.purchases !== null) {
            toReturn += '\t' + ghgi.purchasesSubmitted + '\t' + Math.round(ghgi.emissions.purchases.intensity.intensity) + '\t' + Math.round(ghgi.emissions.purchases.intensity.uncertainty)
          } else {
            toReturn += '\tfalse\tnull\tnull'
          }
          return (toReturn)
        })
      ]
        .join('\n')
        .replace(/(^\[)|(\]$)/gm, '')
      const data = encodeURI(csvContent)
      const link = document.createElement('a')
      link.setAttribute('href', data)
      link.setAttribute('download', 'GES1point5Fullexport_' + now.getFullYear() + '' + month + '' + now.getDate() + '.tsv')
      link.click()
    }
  },
  mounted () {
    const loadingComponent = this.$buefy.loading.open({
      container: null
    })
    this.$store.dispatch('superadmin/getAllGHGI')
      .then(data => {
        loadingComponent.close()
      })
      .catch(() => {
        loadingComponent.close()
      })
  }
}
</script>
